within ;
package A6M33MOS "Modelovani a simulace"
  package Seminar_02
    package Library
      connector joint "konektor"
      Real y "The y position";
      flow Real f "force";
      end joint;

      model mass

        joint joint1 annotation (Placement(transformation(extent={{-10,80},{10,100}}),
              iconTransformation(extent={{-10,80},{10,100}})));
        Real y;
        parameter Real initPos=0 "Pocatecni vychylka";

      initial equation
        y = initPos;
      equation
        joint1.y = y;
        annotation (Icon(graphics={Ellipse(
                extent={{-80,80},{80,-80}},
                fillColor={0,0,0},
                fillPattern=FillPattern.Solid,
                pattern=LinePattern.None)}));
      end mass;
    end Library;

    package HH
      model NaKanal

        extends Modelica.Electrical.Analog.Interfaces.OnePort;

        parameter Real gNa=120 "vodivost Na kanalu";
        parameter Real E_Na=40 "potencial pro rovnovazny stav Na kanalu";
        Real V "napeti na membrane";
        Real m "normalizovany pocet otevrenych aktivacnich bran";
        Real am "rychlost otvirani aktivacnich bran";
        Real bm "rychlost zavirani aktivacnich bran";
        Real h "normalizovany pocet otevrenych inaktivacnich bran";
        Real ah "rychlost zavirani inaktivacnich bran";
        Real bh "rychlost otvirani inaktivacnich bran";
        Real G "vodivost na membrane";
        Real R "odpor na membrane";

      initial equation
          m=0.05;
        h=0.6;

      equation
        v=V+E_Na;

         der(m)=am*(1 - m) - bm*m;
        am=-(0.1*(v + 50))/(exp(-(v + 50)/10) - 1);
        bm=4*exp(-(v + 75)/18);
        der(h)=ah*(1 - h) - bh*h;
        ah=0.07*exp(-(v + 75)/20);
        bh=1/(exp(-(v + 45)/10) + 1);

        i=gNa*m^3*h*V;
        i=G*V;
        R*G=1;

        annotation (Icon(graphics));
      end NaKanal;

      model KKanal "Toto je K kanal"
        extends Modelica.Electrical.Analog.Interfaces.OnePort;

        parameter Real gk=36 "vodivost K kanalu";
        parameter Real E_K=-87 "potencial pro rovnovazny stav K kanalu";
        Real V "napeti na membrane";
        Real nn "normalizovany pocet otevrenych aktivacnich bran";
        Real an "rychlost otvirani aktivacnich bran";
        Real bn "rychlost zavirani aktivacnich bran";
        Real G "vodivost na membrane";
        Real R "odpor na membrane";

      initial equation
          nn=0.325;

      equation
        v=V+E_K;

         der(nn)=an*(1 - nn) - bn*nn;
        an=-(0.01*(v + 65))/(exp(-(v + 65)/10) - 1);
        bn=0.125*exp((v + 75)/80);

        i=gK*nn^4*V;
        i=G*V;
        R*G=1;
      end KKanal;
    end HH;
  end Seminar_02;
  annotation (uses(Modelica(version="3.2")));
end A6M33MOS;
